package progressgrouptest.job;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;

public final class TestJob extends Job {

  private final int number;

  public TestJob(final int number) {
    super("TestJob-" + String.valueOf(number));
    this.number = number;
  }

  @Override
  protected final IStatus run(final IProgressMonitor monitor) {
    int work = 5;
    monitor.beginTask("main task " + String.valueOf(this.number), work);
    for (; work > 0; work--) {
      System.out.println("main task " + String.valueOf(this.number) + ": begin " + (5 - work));
      try {
        Thread.sleep(Math.max(3000, (int) Math.round(Math.random() * 10000)));
      } catch (final InterruptedException e) {
        // Ignore. Just a test case.
      } finally {
        System.out.println("main task " + String.valueOf(this.number) + ": end " + (5 - work));
        monitor.worked(1);
      }
    }

    monitor.done();

    return Status.OK_STATUS;
  }
}
