package progressgrouptest.views;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.ui.part.ViewPart;
import progressgrouptest.job.TestJob;

public final class ProgressGroupTestView extends ViewPart {

  public static final String ID = "progressgrouptest.views.SampleView";

  private Button button;

  public ProgressGroupTestView() {
    super();
  }

  @Override
  public final void createPartControl(final Composite parent) {
    final Composite viewParent = new Composite(parent, SWT.None);
    viewParent.setLayout(new FillLayout());

    this.button = new Button(viewParent, SWT.PUSH);
    this.button.setText("execute");
    this.button.addListener(SWT.Selection, new Listener() {
      public final void handleEvent(final Event event) {
        runJobs();
      }
    });
  }

  @Override
  public final void setFocus() {
    if (this.button != null) {
      this.button.setFocus();
    }
  }

  private final void runJobs() {
    final Thread thread = new Thread() {
      @Override
      public final void run() {
        final IProgressMonitor groupMonitor = Job.getJobManager().createProgressGroup();
        final int count = 10;
        final TestJob[] jobs = new TestJob[count];
        for (int index = 0; index < count; index++) {
          jobs[index] = new TestJob(index);
          jobs[index].setProgressGroup(groupMonitor, 1);
        }

        groupMonitor.beginTask("Running a test", count);

        for (int index = 0; index < count; index++) {
          jobs[index].schedule();
        }

        for (int index = 0; index < count; index++) {
          try {
            jobs[index].join();
          } catch (final InterruptedException e) {
            // Ignore. Just a test case.
          }
        }

        groupMonitor.done();
      }
    };
    thread.start();
  }
}
